<?php

namespace OurivesWeb;

use OurivesWeb\Type;
use Phpro\SoapClient\Soap\ClassMap\ClassMapCollection;
use Phpro\SoapClient\Soap\ClassMap\ClassMap;

class OurivesWebClassmap
{

    public static function getCollection() : \Phpro\SoapClient\Soap\ClassMap\ClassMapCollection
    {
        return new ClassMapCollection([
            new ClassMap('Versao', Type\Versao::class),
            new ClassMap('VersaoResponse', Type\VersaoResponse::class),
            new ClassMap('ValidaLogin', Type\ValidaLogin::class),
            new ClassMap('ValidaLoginResponse', Type\ValidaLoginResponse::class),
            new ClassMap('GetEmpresa', Type\GetEmpresa::class),
            new ClassMap('GetEmpresaResponse', Type\GetEmpresaResponse::class),
            new ClassMap('InvoiceTransporte', Type\InvoiceTransporte::class),
            new ClassMap('InvoiceTransporteResponse', Type\InvoiceTransporteResponse::class),
            new ClassMap('GetArtigosImageList', Type\GetArtigosImageList::class),
            new ClassMap('GetArtigosImageListResponse', Type\GetArtigosImageListResponse::class),
            new ClassMap('GetArtigoStockRef', Type\GetArtigoStockRef::class),
            new ClassMap('GetArtigoStockRefResponse', Type\GetArtigoStockRefResponse::class),
            new ClassMap('GetPaises', Type\GetPaises::class),
            new ClassMap('GetPaisesResponse', Type\GetPaisesResponse::class),
            new ClassMap('GetClientes', Type\GetClientes::class),
            new ClassMap('GetClientesResponse', Type\GetClientesResponse::class),
            new ClassMap('GetFornece', Type\GetFornece::class),
            new ClassMap('GetForneceResponse', Type\GetForneceResponse::class),
            new ClassMap('GetForneceNumero', Type\GetForneceNumero::class),
            new ClassMap('GetForneceNumeroResponse', Type\GetForneceNumeroResponse::class),
            new ClassMap('GetForneceNif', Type\GetForneceNif::class),
            new ClassMap('GetForneceNifResponse', Type\GetForneceNifResponse::class),
            new ClassMap('GetForneceMail', Type\GetForneceMail::class),
            new ClassMap('GetForneceMailResponse', Type\GetForneceMailResponse::class),
            new ClassMap('GetForneceTlf', Type\GetForneceTlf::class),
            new ClassMap('GetForneceTlfResponse', Type\GetForneceTlfResponse::class),
            new ClassMap('GetCcrCli', Type\GetCcrCli::class),
            new ClassMap('GetCcrCliResponse', Type\GetCcrCliResponse::class),
            new ClassMap('GetStockUpdates', Type\GetStockUpdates::class),
            new ClassMap('GetStockUpdatesResponse', Type\GetStockUpdatesResponse::class),
            new ClassMap('GetStockUpdatesbyMinutes', Type\GetStockUpdatesbyMinutes::class),
            new ClassMap('GetStockUpdatesbyMinutesResponse', Type\GetStockUpdatesbyMinutesResponse::class),
            new ClassMap('GetArtigosUpdates', Type\GetArtigosUpdates::class),
            new ClassMap('GetArtigosUpdatesResponse', Type\GetArtigosUpdatesResponse::class),
            new ClassMap('GetArtigosUpdatesbyMinutes', Type\GetArtigosUpdatesbyMinutes::class),
            new ClassMap('GetArtigosUpdatesbyMinutesResponse', Type\GetArtigosUpdatesbyMinutesResponse::class),
            new ClassMap('UpLoadImage', Type\UpLoadImage::class),
            new ClassMap('UpLoadImageResponse', Type\UpLoadImageResponse::class),
            new ClassMap('DownloadImage', Type\DownloadImage::class),
            new ClassMap('DownloadImageResponse', Type\DownloadImageResponse::class),
            new ClassMap('DownloadImages', Type\DownloadImages::class),
            new ClassMap('DownloadImagesResponse', Type\DownloadImagesResponse::class),
            new ClassMap('GetPndCli', Type\GetPndCli::class),
            new ClassMap('GetPndCliResponse', Type\GetPndCliResponse::class),
            new ClassMap('GetCliVendas', Type\GetCliVendas::class),
            new ClassMap('GetCliVendasResponse', Type\GetCliVendasResponse::class),
            new ClassMap('GetVendas', Type\GetVendas::class),
            new ClassMap('GetVendasResponse', Type\GetVendasResponse::class),
            new ClassMap('GetVenda', Type\GetVenda::class),
            new ClassMap('GetVendaResponse', Type\GetVendaResponse::class),
            new ClassMap('GetVendaLinhas', Type\GetVendaLinhas::class),
            new ClassMap('GetVendaLinhasResponse', Type\GetVendaLinhasResponse::class),
            new ClassMap('GetPndFor', Type\GetPndFor::class),
            new ClassMap('GetPndForResponse', Type\GetPndForResponse::class),
            new ClassMap('GetCcrFor', Type\GetCcrFor::class),
            new ClassMap('GetCcrForResponse', Type\GetCcrForResponse::class),
            new ClassMap('GetClientesNumero', Type\GetClientesNumero::class),
            new ClassMap('GetClientesNumeroResponse', Type\GetClientesNumeroResponse::class),
            new ClassMap('GetClientesNif', Type\GetClientesNif::class),
            new ClassMap('GetClientesNifResponse', Type\GetClientesNifResponse::class),
            new ClassMap('GetClientesMail', Type\GetClientesMail::class),
            new ClassMap('GetClientesMailResponse', Type\GetClientesMailResponse::class),
            new ClassMap('GetClientesTlf', Type\GetClientesTlf::class),
            new ClassMap('GetClientesTlfResponse', Type\GetClientesTlfResponse::class),
            new ClassMap('GetAssSerie', Type\GetAssSerie::class),
            new ClassMap('GetAssSerieResponse', Type\GetAssSerieResponse::class),
            new ClassMap('GetArtigoRef', Type\GetArtigoRef::class),
            new ClassMap('GetArtigoRefResponse', Type\GetArtigoRefResponse::class),
            new ClassMap('GetArtigoCod', Type\GetArtigoCod::class),
            new ClassMap('GetArtigoCodResponse', Type\GetArtigoCodResponse::class),
            new ClassMap('GetArtigoFamSfa', Type\GetArtigoFamSfa::class),
            new ClassMap('GetArtigoFamSfaResponse', Type\GetArtigoFamSfaResponse::class),
            new ClassMap('GetArtigoMarca', Type\GetArtigoMarca::class),
            new ClassMap('GetArtigoMarcaResponse', Type\GetArtigoMarcaResponse::class),
            new ClassMap('GetFamilias', Type\GetFamilias::class),
            new ClassMap('GetFamiliasResponse', Type\GetFamiliasResponse::class),
            new ClassMap('GetSubFamilias', Type\GetSubFamilias::class),
            new ClassMap('GetSubFamiliasResponse', Type\GetSubFamiliasResponse::class),
            new ClassMap('GetSeccoes', Type\GetSeccoes::class),
            new ClassMap('GetSeccoesResponse', Type\GetSeccoesResponse::class),
            new ClassMap('GetMarcas', Type\GetMarcas::class),
            new ClassMap('GetMarcasResponse', Type\GetMarcasResponse::class),
            new ClassMap('GetMotivosIsento', Type\GetMotivosIsento::class),
            new ClassMap('GetMotivosIsentoResponse', Type\GetMotivosIsentoResponse::class),
            new ClassMap('GetMotivosCredito', Type\GetMotivosCredito::class),
            new ClassMap('GetMotivosCreditoResponse', Type\GetMotivosCreditoResponse::class),
            new ClassMap('GetCondPag', Type\GetCondPag::class),
            new ClassMap('GetCondPagResponse', Type\GetCondPagResponse::class),
            new ClassMap('GetMaterias', Type\GetMaterias::class),
            new ClassMap('GetMateriasResponse', Type\GetMateriasResponse::class),
            new ClassMap('GetToques', Type\GetToques::class),
            new ClassMap('GetToquesResponse', Type\GetToquesResponse::class),
            new ClassMap('GetModPag', Type\GetModPag::class),
            new ClassMap('GetModPagResponse', Type\GetModPagResponse::class),
            new ClassMap('GetDocVnd', Type\GetDocVnd::class),
            new ClassMap('GetDocVndResponse', Type\GetDocVndResponse::class),
            new ClassMap('GetVendedores', Type\GetVendedores::class),
            new ClassMap('GetVendedoresResponse', Type\GetVendedoresResponse::class),
            new ClassMap('GetArtigos', Type\GetArtigos::class),
            new ClassMap('GetArtigosResponse', Type\GetArtigosResponse::class),
            new ClassMap('EditCliente', Type\EditCliente::class),
            new ClassMap('EditClienteResponse', Type\EditClienteResponse::class),
            new ClassMap('EditFornecedor', Type\EditFornecedor::class),
            new ClassMap('EditFornecedorResponse', Type\EditFornecedorResponse::class),
            new ClassMap('EditOutro', Type\EditOutro::class),
            new ClassMap('EditOutroResponse', Type\EditOutroResponse::class),
            new ClassMap('EditFamilia', Type\EditFamilia::class),
            new ClassMap('EditFamiliaResponse', Type\EditFamiliaResponse::class),
            new ClassMap('EditSubFamilia', Type\EditSubFamilia::class),
            new ClassMap('EditSubFamiliaResponse', Type\EditSubFamiliaResponse::class),
            new ClassMap('EditVendedor', Type\EditVendedor::class),
            new ClassMap('EditVendedorResponse', Type\EditVendedorResponse::class),
            new ClassMap('EditMarca', Type\EditMarca::class),
            new ClassMap('EditMarcaResponse', Type\EditMarcaResponse::class),
            new ClassMap('EditArtigo', Type\EditArtigo::class),
            new ClassMap('EditArtigoResponse', Type\EditArtigoResponse::class),
            new ClassMap('InsertInvoice', Type\InsertInvoice::class),
            new ClassMap('InsertInvoiceResponse', Type\InsertInvoiceResponse::class),
            new ClassMap('InsertInvoiceLine', Type\InsertInvoiceLine::class),
            new ClassMap('InsertInvoiceLineResponse', Type\InsertInvoiceLineResponse::class),
            new ClassMap('CloseInvoice', Type\CloseInvoice::class),
            new ClassMap('CloseInvoiceResponse', Type\CloseInvoiceResponse::class),
            new ClassMap('InvoiceMotivoIsento', Type\InvoiceMotivoIsento::class),
            new ClassMap('InvoiceMotivoIsentoResponse', Type\InvoiceMotivoIsentoResponse::class),
            new ClassMap('InvoiceMotivoCredito', Type\InvoiceMotivoCredito::class),
            new ClassMap('InvoiceMotivoCreditoResponse', Type\InvoiceMotivoCreditoResponse::class),
            new ClassMap('DeleteInvoice', Type\DeleteInvoice::class),
            new ClassMap('DeleteInvoiceResponse', Type\DeleteInvoiceResponse::class),
            new ClassMap('PayInvoice', Type\PayInvoice::class),
            new ClassMap('PayInvoiceResponse', Type\PayInvoiceResponse::class),
            new ClassMap('InvoicePdf', Type\InvoicePdf::class),
            new ClassMap('InvoicePdfResponse', Type\InvoicePdfResponse::class),
            new ClassMap('ReceiptPdf', Type\ReceiptPdf::class),
            new ClassMap('ReceiptPdfResponse', Type\ReceiptPdfResponse::class),
        ]);
    }


}

