<?php

namespace OurivesWeb;

use OurivesWeb\Type;
use Phpro\SoapClient\Type\ResultInterface;
use Phpro\SoapClient\Exception\SoapException;
use Phpro\SoapClient\Type\RequestInterface;

class OurivesWebClient extends \Phpro\SoapClient\Client
{

    /**
     * @param RequestInterface|Type\Versao $parameters
     * @return ResultInterface|Type\VersaoResponse
     * @throws SoapException
     */
    public function versao(\OurivesWeb\Type\Versao $parameters) : \OurivesWeb\Type\VersaoResponse
    {
        return $this->call('Versao', $parameters);
    }

    /**
     * @param RequestInterface|Type\ValidaLogin $parameters
     * @return ResultInterface|Type\ValidaLoginResponse
     * @throws SoapException
     */
    public function validaLogin(\OurivesWeb\Type\ValidaLogin $parameters) : \OurivesWeb\Type\ValidaLoginResponse
    {
        return $this->call('ValidaLogin', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetEmpresa $parameters
     * @return ResultInterface|Type\GetEmpresaResponse
     * @throws SoapException
     */
    public function getEmpresa(\OurivesWeb\Type\GetEmpresa $parameters) : \OurivesWeb\Type\GetEmpresaResponse
    {
        return $this->call('GetEmpresa', $parameters);
    }

    /**
     * @param RequestInterface|Type\InvoiceTransporte $parameters
     * @return ResultInterface|Type\InvoiceTransporteResponse
     * @throws SoapException
     */
    public function invoiceTransporte(\OurivesWeb\Type\InvoiceTransporte $parameters) : \OurivesWeb\Type\InvoiceTransporteResponse
    {
        return $this->call('InvoiceTransporte', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigosImageList $parameters
     * @return ResultInterface|Type\GetArtigosImageListResponse
     * @throws SoapException
     */
    public function getArtigosImageList(\OurivesWeb\Type\GetArtigosImageList $parameters) : \OurivesWeb\Type\GetArtigosImageListResponse
    {
        return $this->call('GetArtigosImageList', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigoStockRef $parameters
     * @return ResultInterface|Type\GetArtigoStockRefResponse
     * @throws SoapException
     */
    public function getArtigoStockRef(\OurivesWeb\Type\GetArtigoStockRef $parameters) : \OurivesWeb\Type\GetArtigoStockRefResponse
    {
        return $this->call('GetArtigoStockRef', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetPaises $parameters
     * @return ResultInterface|Type\GetPaisesResponse
     * @throws SoapException
     */
    public function getPaises(\OurivesWeb\Type\GetPaises $parameters) : \OurivesWeb\Type\GetPaisesResponse
    {
        return $this->call('GetPaises', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetClientes $parameters
     * @return ResultInterface|Type\GetClientesResponse
     * @throws SoapException
     */
    public function getClientes(\OurivesWeb\Type\GetClientes $parameters) : \OurivesWeb\Type\GetClientesResponse
    {
        return $this->call('GetClientes', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetFornece $parameters
     * @return ResultInterface|Type\GetForneceResponse
     * @throws SoapException
     */
    public function getFornece(\OurivesWeb\Type\GetFornece $parameters) : \OurivesWeb\Type\GetForneceResponse
    {
        return $this->call('GetFornece', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetForneceNumero $parameters
     * @return ResultInterface|Type\GetForneceNumeroResponse
     * @throws SoapException
     */
    public function getForneceNumero(\OurivesWeb\Type\GetForneceNumero $parameters) : \OurivesWeb\Type\GetForneceNumeroResponse
    {
        return $this->call('GetForneceNumero', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetForneceNif $parameters
     * @return ResultInterface|Type\GetForneceNifResponse
     * @throws SoapException
     */
    public function getForneceNif(\OurivesWeb\Type\GetForneceNif $parameters) : \OurivesWeb\Type\GetForneceNifResponse
    {
        return $this->call('GetForneceNif', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetForneceMail $parameters
     * @return ResultInterface|Type\GetForneceMailResponse
     * @throws SoapException
     */
    public function getForneceMail(\OurivesWeb\Type\GetForneceMail $parameters) : \OurivesWeb\Type\GetForneceMailResponse
    {
        return $this->call('GetForneceMail', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetForneceTlf $parameters
     * @return ResultInterface|Type\GetForneceTlfResponse
     * @throws SoapException
     */
    public function getForneceTlf(\OurivesWeb\Type\GetForneceTlf $parameters) : \OurivesWeb\Type\GetForneceTlfResponse
    {
        return $this->call('GetForneceTlf', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetCcrCli $parameters
     * @return ResultInterface|Type\GetCcrCliResponse
     * @throws SoapException
     */
    public function getCcrCli(\OurivesWeb\Type\GetCcrCli $parameters) : \OurivesWeb\Type\GetCcrCliResponse
    {
        return $this->call('GetCcrCli', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetStockUpdates $parameters
     * @return ResultInterface|Type\GetStockUpdatesResponse
     * @throws SoapException
     */
    public function getStockUpdates(\OurivesWeb\Type\GetStockUpdates $parameters) : \OurivesWeb\Type\GetStockUpdatesResponse
    {
        return $this->call('GetStockUpdates', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetStockUpdatesbyMinutes $parameters
     * @return ResultInterface|Type\GetStockUpdatesbyMinutesResponse
     * @throws SoapException
     */
    public function getStockUpdatesbyMinutes(\OurivesWeb\Type\GetStockUpdatesbyMinutes $parameters) : \OurivesWeb\Type\GetStockUpdatesbyMinutesResponse
    {
        return $this->call('GetStockUpdatesbyMinutes', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigosUpdates $parameters
     * @return ResultInterface|Type\GetArtigosUpdatesResponse
     * @throws SoapException
     */
    public function getArtigosUpdates(\OurivesWeb\Type\GetArtigosUpdates $parameters) : \OurivesWeb\Type\GetArtigosUpdatesResponse
    {
        return $this->call('GetArtigosUpdates', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigosUpdatesbyMinutes $parameters
     * @return ResultInterface|Type\GetArtigosUpdatesbyMinutesResponse
     * @throws SoapException
     */
    public function getArtigosUpdatesbyMinutes(\OurivesWeb\Type\GetArtigosUpdatesbyMinutes $parameters) : \OurivesWeb\Type\GetArtigosUpdatesbyMinutesResponse
    {
        return $this->call('GetArtigosUpdatesbyMinutes', $parameters);
    }

    /**
     * @param RequestInterface|Type\UpLoadImage $parameters
     * @return ResultInterface|Type\UpLoadImageResponse
     * @throws SoapException
     */
    public function upLoadImage(\OurivesWeb\Type\UpLoadImage $parameters) : \OurivesWeb\Type\UpLoadImageResponse
    {
        return $this->call('UpLoadImage', $parameters);
    }

    /**
     * @param RequestInterface|Type\DownloadImage $parameters
     * @return ResultInterface|Type\DownloadImageResponse
     * @throws SoapException
     */
    public function downloadImage(\OurivesWeb\Type\DownloadImage $parameters) : \OurivesWeb\Type\DownloadImageResponse
    {
        return $this->call('DownloadImage', $parameters);
    }

    /**
     * @param RequestInterface|Type\DownloadImages $parameters
     * @return ResultInterface|Type\DownloadImagesResponse
     * @throws SoapException
     */
    public function downloadImages(\OurivesWeb\Type\DownloadImages $parameters) : \OurivesWeb\Type\DownloadImagesResponse
    {
        return $this->call('DownloadImages', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetPndCli $parameters
     * @return ResultInterface|Type\GetPndCliResponse
     * @throws SoapException
     */
    public function getPndCli(\OurivesWeb\Type\GetPndCli $parameters) : \OurivesWeb\Type\GetPndCliResponse
    {
        return $this->call('GetPndCli', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetCliVendas $parameters
     * @return ResultInterface|Type\GetCliVendasResponse
     * @throws SoapException
     */
    public function getCliVendas(\OurivesWeb\Type\GetCliVendas $parameters) : \OurivesWeb\Type\GetCliVendasResponse
    {
        return $this->call('GetCliVendas', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetVendas $parameters
     * @return ResultInterface|Type\GetVendasResponse
     * @throws SoapException
     */
    public function getVendas(\OurivesWeb\Type\GetVendas $parameters) : \OurivesWeb\Type\GetVendasResponse
    {
        return $this->call('GetVendas', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetVenda $parameters
     * @return ResultInterface|Type\GetVendaResponse
     * @throws SoapException
     */
    public function getVenda(\OurivesWeb\Type\GetVenda $parameters) : \OurivesWeb\Type\GetVendaResponse
    {
        return $this->call('GetVenda', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetVendaLinhas $parameters
     * @return ResultInterface|Type\GetVendaLinhasResponse
     * @throws SoapException
     */
    public function getVendaLinhas(\OurivesWeb\Type\GetVendaLinhas $parameters) : \OurivesWeb\Type\GetVendaLinhasResponse
    {
        return $this->call('GetVendaLinhas', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetPndFor $parameters
     * @return ResultInterface|Type\GetPndForResponse
     * @throws SoapException
     */
    public function getPndFor(\OurivesWeb\Type\GetPndFor $parameters) : \OurivesWeb\Type\GetPndForResponse
    {
        return $this->call('GetPndFor', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetCcrFor $parameters
     * @return ResultInterface|Type\GetCcrForResponse
     * @throws SoapException
     */
    public function getCcrFor(\OurivesWeb\Type\GetCcrFor $parameters) : \OurivesWeb\Type\GetCcrForResponse
    {
        return $this->call('GetCcrFor', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetClientesNumero $parameters
     * @return ResultInterface|Type\GetClientesNumeroResponse
     * @throws SoapException
     */
    public function getClientesNumero(\OurivesWeb\Type\GetClientesNumero $parameters) : \OurivesWeb\Type\GetClientesNumeroResponse
    {
        return $this->call('GetClientesNumero', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetClientesNif $parameters
     * @return ResultInterface|Type\GetClientesNifResponse
     * @throws SoapException
     */
    public function getClientesNif(\OurivesWeb\Type\GetClientesNif $parameters) : \OurivesWeb\Type\GetClientesNifResponse
    {
        return $this->call('GetClientesNif', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetClientesMail $parameters
     * @return ResultInterface|Type\GetClientesMailResponse
     * @throws SoapException
     */
    public function getClientesMail(\OurivesWeb\Type\GetClientesMail $parameters) : \OurivesWeb\Type\GetClientesMailResponse
    {
        return $this->call('GetClientesMail', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetClientesTlf $parameters
     * @return ResultInterface|Type\GetClientesTlfResponse
     * @throws SoapException
     */
    public function getClientesTlf(\OurivesWeb\Type\GetClientesTlf $parameters) : \OurivesWeb\Type\GetClientesTlfResponse
    {
        return $this->call('GetClientesTlf', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetAssSerie $parameters
     * @return ResultInterface|Type\GetAssSerieResponse
     * @throws SoapException
     */
    public function getAssSerie(\OurivesWeb\Type\GetAssSerie $parameters) : \OurivesWeb\Type\GetAssSerieResponse
    {
        return $this->call('GetAssSerie', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigoRef $parameters
     * @return ResultInterface|Type\GetArtigoRefResponse
     * @throws SoapException
     */
    public function getArtigoRef(\OurivesWeb\Type\GetArtigoRef $parameters) : \OurivesWeb\Type\GetArtigoRefResponse
    {
        return $this->call('GetArtigoRef', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigoCod $parameters
     * @return ResultInterface|Type\GetArtigoCodResponse
     * @throws SoapException
     */
    public function getArtigoCod(\OurivesWeb\Type\GetArtigoCod $parameters) : \OurivesWeb\Type\GetArtigoCodResponse
    {
        return $this->call('GetArtigoCod', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigoFamSfa $parameters
     * @return ResultInterface|Type\GetArtigoFamSfaResponse
     * @throws SoapException
     */
    public function getArtigoFamSfa(\OurivesWeb\Type\GetArtigoFamSfa $parameters) : \OurivesWeb\Type\GetArtigoFamSfaResponse
    {
        return $this->call('GetArtigoFamSfa', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigoMarca $parameters
     * @return ResultInterface|Type\GetArtigoMarcaResponse
     * @throws SoapException
     */
    public function getArtigoMarca(\OurivesWeb\Type\GetArtigoMarca $parameters) : \OurivesWeb\Type\GetArtigoMarcaResponse
    {
        return $this->call('GetArtigoMarca', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetFamilias $parameters
     * @return ResultInterface|Type\GetFamiliasResponse
     * @throws SoapException
     */
    public function getFamilias(\OurivesWeb\Type\GetFamilias $parameters) : \OurivesWeb\Type\GetFamiliasResponse
    {
        return $this->call('GetFamilias', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetSubFamilias $parameters
     * @return ResultInterface|Type\GetSubFamiliasResponse
     * @throws SoapException
     */
    public function getSubFamilias(\OurivesWeb\Type\GetSubFamilias $parameters) : \OurivesWeb\Type\GetSubFamiliasResponse
    {
        return $this->call('GetSubFamilias', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetSeccoes $parameters
     * @return ResultInterface|Type\GetSeccoesResponse
     * @throws SoapException
     */
    public function getSeccoes(\OurivesWeb\Type\GetSeccoes $parameters) : \OurivesWeb\Type\GetSeccoesResponse
    {
        return $this->call('GetSeccoes', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetMarcas $parameters
     * @return ResultInterface|Type\GetMarcasResponse
     * @throws SoapException
     */
    public function getMarcas(\OurivesWeb\Type\GetMarcas $parameters) : \OurivesWeb\Type\GetMarcasResponse
    {
        return $this->call('GetMarcas', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetMotivosIsento $parameters
     * @return ResultInterface|Type\GetMotivosIsentoResponse
     * @throws SoapException
     */
    public function getMotivosIsento(\OurivesWeb\Type\GetMotivosIsento $parameters) : \OurivesWeb\Type\GetMotivosIsentoResponse
    {
        return $this->call('GetMotivosIsento', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetMotivosCredito $parameters
     * @return ResultInterface|Type\GetMotivosCreditoResponse
     * @throws SoapException
     */
    public function getMotivosCredito(\OurivesWeb\Type\GetMotivosCredito $parameters) : \OurivesWeb\Type\GetMotivosCreditoResponse
    {
        return $this->call('GetMotivosCredito', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetCondPag $parameters
     * @return ResultInterface|Type\GetCondPagResponse
     * @throws SoapException
     */
    public function getCondPag(\OurivesWeb\Type\GetCondPag $parameters) : \OurivesWeb\Type\GetCondPagResponse
    {
        return $this->call('GetCondPag', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetMaterias $parameters
     * @return ResultInterface|Type\GetMateriasResponse
     * @throws SoapException
     */
    public function getMaterias(\OurivesWeb\Type\GetMaterias $parameters) : \OurivesWeb\Type\GetMateriasResponse
    {
        return $this->call('GetMaterias', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetToques $parameters
     * @return ResultInterface|Type\GetToquesResponse
     * @throws SoapException
     */
    public function getToques(\OurivesWeb\Type\GetToques $parameters) : \OurivesWeb\Type\GetToquesResponse
    {
        return $this->call('GetToques', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetModPag $parameters
     * @return ResultInterface|Type\GetModPagResponse
     * @throws SoapException
     */
    public function getModPag(\OurivesWeb\Type\GetModPag $parameters) : \OurivesWeb\Type\GetModPagResponse
    {
        return $this->call('GetModPag', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetDocVnd $parameters
     * @return ResultInterface|Type\GetDocVndResponse
     * @throws SoapException
     */
    public function getDocVnd(\OurivesWeb\Type\GetDocVnd $parameters) : \OurivesWeb\Type\GetDocVndResponse
    {
        return $this->call('GetDocVnd', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetVendedores $parameters
     * @return ResultInterface|Type\GetVendedoresResponse
     * @throws SoapException
     */
    public function getVendedores(\OurivesWeb\Type\GetVendedores $parameters) : \OurivesWeb\Type\GetVendedoresResponse
    {
        return $this->call('GetVendedores', $parameters);
    }

    /**
     * @param RequestInterface|Type\GetArtigos $parameters
     * @return ResultInterface|Type\GetArtigosResponse
     * @throws SoapException
     */
    public function getArtigos(\OurivesWeb\Type\GetArtigos $parameters) : \OurivesWeb\Type\GetArtigosResponse
    {
        return $this->call('GetArtigos', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditCliente $parameters
     * @return ResultInterface|Type\EditClienteResponse
     * @throws SoapException
     */
    public function editCliente(\OurivesWeb\Type\EditCliente $parameters) : \OurivesWeb\Type\EditClienteResponse
    {
        return $this->call('EditCliente', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditFornecedor $parameters
     * @return ResultInterface|Type\EditFornecedorResponse
     * @throws SoapException
     */
    public function editFornecedor(\OurivesWeb\Type\EditFornecedor $parameters) : \OurivesWeb\Type\EditFornecedorResponse
    {
        return $this->call('EditFornecedor', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditOutro $parameters
     * @return ResultInterface|Type\EditOutroResponse
     * @throws SoapException
     */
    public function editOutro(\OurivesWeb\Type\EditOutro $parameters) : \OurivesWeb\Type\EditOutroResponse
    {
        return $this->call('EditOutro', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditFamilia $parameters
     * @return ResultInterface|Type\EditFamiliaResponse
     * @throws SoapException
     */
    public function editFamilia(\OurivesWeb\Type\EditFamilia $parameters) : \OurivesWeb\Type\EditFamiliaResponse
    {
        return $this->call('EditFamilia', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditSubFamilia $parameters
     * @return ResultInterface|Type\EditSubFamiliaResponse
     * @throws SoapException
     */
    public function editSubFamilia(\OurivesWeb\Type\EditSubFamilia $parameters) : \OurivesWeb\Type\EditSubFamiliaResponse
    {
        return $this->call('EditSubFamilia', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditVendedor $parameters
     * @return ResultInterface|Type\EditVendedorResponse
     * @throws SoapException
     */
    public function editVendedor(\OurivesWeb\Type\EditVendedor $parameters) : \OurivesWeb\Type\EditVendedorResponse
    {
        return $this->call('EditVendedor', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditMarca $parameters
     * @return ResultInterface|Type\EditMarcaResponse
     * @throws SoapException
     */
    public function editMarca(\OurivesWeb\Type\EditMarca $parameters) : \OurivesWeb\Type\EditMarcaResponse
    {
        return $this->call('EditMarca', $parameters);
    }

    /**
     * @param RequestInterface|Type\EditArtigo $parameters
     * @return ResultInterface|Type\EditArtigoResponse
     * @throws SoapException
     */
    public function editArtigo(\OurivesWeb\Type\EditArtigo $parameters) : \OurivesWeb\Type\EditArtigoResponse
    {
        return $this->call('EditArtigo', $parameters);
    }

    /**
     * @param RequestInterface|Type\InsertInvoice $parameters
     * @return ResultInterface|Type\InsertInvoiceResponse
     * @throws SoapException
     */
    public function insertInvoice(\OurivesWeb\Type\InsertInvoice $parameters) : \OurivesWeb\Type\InsertInvoiceResponse
    {
        return $this->call('InsertInvoice', $parameters);
    }

    /**
     * @param RequestInterface|Type\InsertInvoiceLine $parameters
     * @return ResultInterface|Type\InsertInvoiceLineResponse
     * @throws SoapException
     */
    public function insertInvoiceLine(\OurivesWeb\Type\InsertInvoiceLine $parameters) : \OurivesWeb\Type\InsertInvoiceLineResponse
    {
        return $this->call('InsertInvoiceLine', $parameters);
    }

    /**
     * @param RequestInterface|Type\CloseInvoice $parameters
     * @return ResultInterface|Type\CloseInvoiceResponse
     * @throws SoapException
     */
    public function closeInvoice(\OurivesWeb\Type\CloseInvoice $parameters) : \OurivesWeb\Type\CloseInvoiceResponse
    {
        return $this->call('CloseInvoice', $parameters);
    }

    /**
     * @param RequestInterface|Type\InvoiceMotivoIsento $parameters
     * @return ResultInterface|Type\InvoiceMotivoIsentoResponse
     * @throws SoapException
     */
    public function invoiceMotivoIsento(\OurivesWeb\Type\InvoiceMotivoIsento $parameters) : \OurivesWeb\Type\InvoiceMotivoIsentoResponse
    {
        return $this->call('InvoiceMotivoIsento', $parameters);
    }

    /**
     * @param RequestInterface|Type\InvoiceMotivoCredito $parameters
     * @return ResultInterface|Type\InvoiceMotivoCreditoResponse
     * @throws SoapException
     */
    public function invoiceMotivoCredito(\OurivesWeb\Type\InvoiceMotivoCredito $parameters) : \OurivesWeb\Type\InvoiceMotivoCreditoResponse
    {
        return $this->call('InvoiceMotivoCredito', $parameters);
    }

    /**
     * @param RequestInterface|Type\DeleteInvoice $parameters
     * @return ResultInterface|Type\DeleteInvoiceResponse
     * @throws SoapException
     */
    public function deleteInvoice(\OurivesWeb\Type\DeleteInvoice $parameters) : \OurivesWeb\Type\DeleteInvoiceResponse
    {
        return $this->call('DeleteInvoice', $parameters);
    }

    /**
     * @param RequestInterface|Type\PayInvoice $parameters
     * @return ResultInterface|Type\PayInvoiceResponse
     * @throws SoapException
     */
    public function payInvoice(\OurivesWeb\Type\PayInvoice $parameters) : \OurivesWeb\Type\PayInvoiceResponse
    {
        return $this->call('PayInvoice', $parameters);
    }

    /**
     * @param RequestInterface|Type\InvoicePdf $parameters
     * @return ResultInterface|Type\InvoicePdfResponse
     * @throws SoapException
     */
    public function invoicePdf(\OurivesWeb\Type\InvoicePdf $parameters) : \OurivesWeb\Type\InvoicePdfResponse
    {
        return $this->call('InvoicePdf', $parameters);
    }

    /**
     * @param RequestInterface|Type\ReceiptPdf $parameters
     * @return ResultInterface|Type\ReceiptPdfResponse
     * @throws SoapException
     */
    public function receiptPdf(\OurivesWeb\Type\ReceiptPdf $parameters) : \OurivesWeb\Type\ReceiptPdfResponse
    {
        return $this->call('ReceiptPdf', $parameters);
    }


}

