<?php

namespace OurivesWeb;

use OurivesWeb\OurivesWebClient;
use OurivesWeb\OurivesWebClassmap;
use Symfony\Component\EventDispatcher\EventDispatcher;
use Phpro\SoapClient\Soap\Driver\ExtSoap\ExtSoapEngineFactory;
use Phpro\SoapClient\Soap\Driver\ExtSoap\ExtSoapOptions;

class OurivesWebClientFactory
{

    public static function factory(string $wsdl) : \OurivesWeb\OurivesWebClient
    {
        $engine = ExtSoapEngineFactory::fromOptions(
            ExtSoapOptions::defaults($wsdl, [])
                ->withClassMap(OurivesWebClassmap::getCollection())
        );
        $eventDispatcher = new EventDispatcher();

        return new OurivesWebClient($engine, $eventDispatcher);
    }


}

